Bug 1463594 - The 'minReadySeconds' does not work in the deploymentconfig
The 'minReadySeconds' does not work in the deploymentconfig
Status: VERIFIED
Product: OpenShift Container Platform
Classification: Red Hat
Component: Deployments (Show other bugs)
3.6.0
Unspecified Unspecified
medium Severity medium
: ---
: 3.6.z
Assigned To: Tomáš Nožička
zhou ying
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-21 05:37 EDT by zhou ying
Modified: 2017-09-18 08:35 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: No Doc Update
Doc Text:
undefined
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description zhou ying 2017-06-21 05:37:31 EDT
Description of problem:
During the  DC's MinReadySeconds, the pod  is not ready for DC, but the DC's status:  unavailableReplicas is 0 , and the readyReplicas equals to replicas asap.

Version-Release number of selected component (if applicable):
openshift v3.6.121
kubernetes v1.6.1+5115d708d7
etcd 3.2.0

How reproducible:
always

Steps to Reproduce:
1. Login openshift and create project;
2. Create a DC with file:
apiVersion: v1
kind: DeploymentConfig
metadata:
  name: minreadytest
spec:
  replicas: 2
  minReadySeconds: 50
  selector:
    name: minreadytest
  template:
    metadata:
      labels:
        name: minreadytest
    spec:
      terminationGracePeriodSeconds: 0
      containers:
      - image: "docker.io/centos:centos7"
        imagePullPolicy: IfNotPresent
        name: myapp
        command:
        - /bin/sleep
        - "10000"
3. Check the dc's status.

Actual results:
3. During the  DC's MinReadySeconds, the unavailableReplicas is 0 and  readyReplicas equals to replicas.

Expected results:
3. During the  DC's MinReadySeconds, the pod is not ready for DC, so the unavailableReplicas should equal to replicas, and the readyReplicas should be 0.

Additional info:
Comment 1 Tomáš Nožička 2017-06-29 10:33:52 EDT
https://github.com/openshift/origin/pull/14936
Comment 2 Tomáš Nožička 2017-07-04 06:42:58 EDT
To clarify on what the expected results are:

During MinReadySecond period: AvailableReplicas == 0 && ReadyReplicas==Replicas && UnavailableReplicas==Replicas
Comment 3 zhou ying 2017-07-04 23:17:59 EDT
Couldn't found the latest ami on EC2, will change the status to modified.
Comment 5 zhou ying 2017-07-06 04:02:31 EDT
Confirmed with latest ocp 3.6 version, the issue has fixed:
[root@ip-172-18-7-226 ~]# openshift version
openshift v3.6.135
kubernetes v1.6.1+5115d708d7
etcd 3.2.1

During MinReadySecond period:
oc get dc minreadytest -o yaml
status:
  availableReplicas: 0
  conditions:
  - lastTransitionTime: 2017-07-06T07:59:01Z
    lastUpdateTime: 2017-07-06T07:59:01Z
    message: Deployment config does not have minimum availability.
    status: "False"
    type: Available
  - lastTransitionTime: 2017-07-06T07:59:01Z
    lastUpdateTime: 2017-07-06T07:59:01Z
    message: replication controller "minreadytest-1" is waiting for pod "minreadytest-1-deploy"
      to run
    status: Unknown
    type: Progressing
  details:
    causes:
    - type: ConfigChange
    message: config change
  latestVersion: 1
  observedGeneration: 2
  readyReplicas: 2
  replicas: 2
  unavailableReplicas: 2
  updatedReplicas: 2

After MinReadySecond period:
status:
  availableReplicas: 2
  conditions:
  - lastTransitionTime: 2017-07-06T07:59:59Z
    lastUpdateTime: 2017-07-06T07:59:59Z
    message: Deployment config has minimum availability.
    status: "True"
    type: Available
  - lastTransitionTime: 2017-07-06T08:00:00Z
    lastUpdateTime: 2017-07-06T08:00:00Z
    message: replication controller "minreadytest-1" successfully rolled out
    reason: NewReplicationControllerAvailable
    status: "True"
    type: Progressing
  details:
    causes:
    - type: ConfigChange
    message: config change
  latestVersion: 1
  observedGeneration: 2
  readyReplicas: 2
  replicas: 2
  unavailableReplicas: 0
  updatedReplicas: 2

Note You need to log in before you can comment on or make changes to this bug.